using PkmnLib.Plugin.Gen7.Scripts.Pokemon;

namespace PkmnLib.Plugin.Gen7.Scripts.Moves;

public abstract class BaseChargeMove<TVolatile> : Script, IScriptPreventMove, IScriptOnBeforeMove,
    IScriptOnSecondaryEffect where TVolatile : RequireChargeEffect
{
    public abstract TVolatile CreateVolatile(IPokemon user);

    public void PreventMove(IExecutingMove move, ref bool prevent)
    {
        if (move.User.Volatile.Contains<TVolatile>())
            return;

        move.User.Volatile.Add(CreateVolatile(move.User));
        move.User.BattleData?.Battle.EventHook.Invoke(new DialogEvent("began_charging", new Dictionary<string, object>
        {
            { "user", move.User },
        }));
        prevent = true;
    }

    /// <inheritdoc />
    public void OnBeforeMove(IExecutingMove move)
    {
        move.User.Volatile.Remove(ScriptUtils.ResolveName<TVolatile>());
    }

    /// <inheritdoc />
    public virtual void OnSecondaryEffect(IExecutingMove move, IPokemon target, byte hit)
    {
    }
}